<?php

/******************************
 * WoWRoster.net  Roster
 * Copyright 2002-2006
 * Licensed under the Creative Commons
 * "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * Short summary
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/
 *
 * Full license information
 *  http://creativecommons.org/licenses/by-nc-sa/2.5/legalcode
 * -----------------------------
 *
 * $Id: membersRep.php 59 2006-06-14 21:17:28Z mathos $
 *
 ******************************/

if( eregi(basename(__FILE__),$_SERVER['PHP_SELF']) )
{
        die("You can't access this file directly!");
}


$query = ("
	SELECT class, COUNT(class) class_count, AVG(level) class_level, MAX(level) class_max
	FROM `".ROSTER_MEMBERSTABLE."`
	GROUP BY class
	ORDER BY class_count DESC, class_level DESC, class_max DESC
	");

$result = $wowdb->query($query);

if($result){
	// Process each class
	while($row = $wowdb->fetch_assoc($result)){

	$avg_level = round($row['class_level'],1);

        foreach ($roster_conf['multilanguages'] as $language)
        {
 	       $icon_name = $wordings[$language]['class_iconArray'][$row['class']];
	        if( strlen($icon_name) > 0 ) break;
        }

	// Get a level breakdown
	$lbq = $wowdb->query("SELECT level FROM `".ROSTER_MEMBERSTABLE."` WHERE class = '".$row['class']."' ORDER BY level");

	$lbr = classBreakdown($lbq);

	if($lbr)
		$overlib = 'onmouseover="return overlib(\''.$lbr.'\',WRAP);" onmouseout="return nd();"';

	// Setup class ICON
        $icon_name = 'Interface/Icons/'.$icon_name;
	$icon_value = '<img class="membersRowimg" width="'.$roster_conf['index_iconsize'].'" height="'.$roster_conf['index_iconsize'].'" src="'.$roster_conf['interface_url'].$icon_name.'.'.$roster_conf['img_suffix'].'" alt="" />&nbsp;';

	$class_output = '<div class="membersGroup"><A HREF="'.$roster_conf['roster_dir'].'/index.php?s=class#'.$row['class'].'" style="color: #CBA300;">'.$icon_value.$row['class'].'</A></div>';


		print border('syellow','start',$class_output);
		print('
		<table border="0" cellpadding="0" cellspacing="0" class="bodyline">
			<tr>
                        <th class="membersHeader">'.$wordings[$roster_conf['roster_lang']]['numbers_ccount'].'</th>
                        <th class="membersHeader">'.$wordings[$roster_conf['roster_lang']]['numbers_hlevel'].'</th>
                        <th class="membersHeaderRight" width="150">'.$wordings[$roster_conf['roster_lang']]['numbers_alevel'].'</th>
                        </tr>
			<tr>
			<td class="membersRow1" style="text-align: center;" '.$overlib.'>'.$row['class_count'].'</td>
			<td class="membersRow1" style="text-align: center;">'.$row['class_max'].'</td>
			<td class="membersRowRight1">
			<div class="levelbarParent" style="width:'.$addon_conf['numbers']['maxLevel'].'px;">
				<div class="levelbarChild">
				'.$avg_level.'
				</div>
			</div>
                                 <table class="expOutline" border="0" cellpadding="0" cellspacing="0" width="100%">
                                 <tr>
                                 <td style="background-image: url(\''.$roster_conf['img_url'].'expbar-var2.gif\');" width="'.$avg_level.'%">
                                 <img src="'.$roster_conf['img_url'].'pixel.gif" height="14" width="1" alt="">
                                 </td>
                                 <td width="'.($addon_conf['numbers']['maxLevel']-$avg_level).'%"></td>
                                 </tr>
                                 </table>
			</td>
		</table>
		');
                print border('syellow','end');
                print "<BR>";

	}

}

function classBreakdown($result)
{
	global $wowdb, $roster_conf, $wordings, $addon_conf;

	// Set defaults
	$sl = $addon_conf['numbers']['sl'];
	$il = $addon_conf['numbers']['il'];
	$ml = $addon_conf['numbers']['maxLevel'];
	$sort = $addon_conf['numbers']['sort'];

	/**************
	Options are as follows:
		sl = Level to start breakdown
		il = Increments of breakdown
		ml = Max level
		sort = Sorting option
	**************/

	######### SAFETY CHECKS ###########

	// It looks silly if you try to do it using 1 incrementing value
	if($il <= 1)
		$il = $addon_conf['numbers']['il'];

	// Level one is as low as we can start
	if($sl < 1)
		$sl = $addon_conf['numbers']['sl'];

	// Starting level can't be higher than max level
	if($sl >= $ml)
		$sl = $addon_conf['numbers']['maxLevel'];

	############# END SAFETY CHECKS ############


	$bl = $sl; // Base level to recall later on for printing fuctions
	$ll = $sl; // used for control

	while($row = $wowdb->fetch_assoc($result))
	{


		if(($row['level'] - $sl) > $il){
			$offset = floor(($row['level'] - ($sl+1)) / $il);
			$sl += $il*$offset;
		}

		if($row['level'] > $sl){
			$ll = $sl;
			$sl += $il;
		} 
		
		$lc[$sl]++;

	}

		// Sorting
		switch($sort)
		{
			// low to high (value of key)
			case 1:
				asort($lc);
				break;
			// high to low (value of key)
			case 2:
				arsort($lc);
				break;
			// standard (by array key)
			default:
				break;
		}

	// Build our output string
		$lstring = "";
		foreach($lc as $k => $v)
		{
			if($k == $bl)
			{
				$lstring .= "<B>$v</B> - Level 1 to $bl <BR>";
			} elseif($k > $ml){
				$lstring .= "<B>$v</B> - Level $ml <BR>";
			} else {
				$lstring .= "<B>$v</B> - Level ".($k - ($il - 1))." to $k <BR>";
			}

		}

			//print $lstring;

		return $lstring;

}

?>
